Python: Difference between revisions

From FreeCAD Documentation
(→‎Description: See Introduction to Python to learn about the Python programming language, and then Python scripting tutorial and FreeCAD Scripting Basics to start scripting in FreeCAD. {{VeryImportantMessage}} to the top)
(Marked this version for translation)
Line 1: Line 1:
<languages/>
<languages/>
<translate>
<translate>
<!--T:1-->
{{VeryImportantMessage|(November 2018) FreeCAD was originally designed to work with Python 2. Many features work with Python 3, but some do not. Making FreeCAD fully support Python 3 is a work in process.}}
{{VeryImportantMessage|(November 2018) FreeCAD was originally designed to work with Python 2. Many features work with Python 3, but some do not. Making FreeCAD fully support Python 3 is a work in process.}}


== Description ==
== Description == <!--T:2-->


<!--T:3-->
[https://www.python.org Python] is a general purpose, high level programming language that is very commonly used in large applications to automate some tasks by creating scripts or [[macros]].
[https://www.python.org Python] is a general purpose, high level programming language that is very commonly used in large applications to automate some tasks by creating scripts or [[macros]].


<!--T:4-->
In FreeCAD, Python code can be used to create various elements programmatically, without needing to click on the graphical user interface. Additionally, many tools and workbenches of FreeCAD are programmed in Python.
In FreeCAD, Python code can be used to create various elements programmatically, without needing to click on the graphical user interface. Additionally, many tools and workbenches of FreeCAD are programmed in Python.


<!--T:5-->
See [[Introduction to Python]] to learn about the Python programming language, and then [[Python scripting tutorial]] and [[FreeCAD Scripting Basics]] to start scripting in FreeCAD.
See [[Introduction to Python]] to learn about the Python programming language, and then [[Python scripting tutorial]] and [[FreeCAD Scripting Basics]] to start scripting in FreeCAD.


<!--T:6-->
When writing Python code, it's advisable to follow [https://www.python.org/dev/peps/pep-0008/ PEP8: Style Guide for Python Code].
When writing Python code, it's advisable to follow [https://www.python.org/dev/peps/pep-0008/ PEP8: Style Guide for Python Code].


== Conventions ==
== Conventions == <!--T:7-->
In this documentation, some conventions for Python examples should be followed.
In this documentation, some conventions for Python examples should be followed.


<!--T:8-->
This is a typical function signature
This is a typical function signature
{{Code|code=
{{Code|code=
Line 21: Line 27:
}}
}}


<!--T:9-->
* Arguments with key-value pairs are optional, with the default value indicated in the signature. This means that the following calls are equivalent:
* Arguments with key-value pairs are optional, with the default value indicated in the signature. This means that the following calls are equivalent:
{{Code|code=
{{Code|code=
Line 30: Line 37:
}}
}}


<!--T:10-->
: In this example the first argument doesn't have a default value so it should always be included.
: In this example the first argument doesn't have a default value so it should always be included.


<!--T:11-->
* When the arguments are given with the explicit key, the optional arguments can be given in any order. This means that the following calls are equivalent:
* When the arguments are given with the explicit key, the optional arguments can be given in any order. This means that the following calls are equivalent:
{{Code|code=
{{Code|code=
Line 40: Line 49:
}}
}}


<!--T:12-->
* Python's guidelines stress readability of code; in particular, parentheses should immediately follow the function name, and a space should follow a comma.
* Python's guidelines stress readability of code; in particular, parentheses should immediately follow the function name, and a space should follow a comma.
{{Code|code=
{{Code|code=
Line 48: Line 58:
}}
}}


<!--T:13-->
* If code needs to be broken over several lines, this should be done at a comma inside brackets or parentheses; the second line should be aligned with the previous one.
* If code needs to be broken over several lines, this should be done at a comma inside brackets or parentheses; the second line should be aligned with the previous one.
{{Code|code=
{{Code|code=
Line 53: Line 64:
2, 4, 5]
2, 4, 5]


<!--T:14-->
Wire = makeWire(pointslist,
Wire = makeWire(pointslist,
False, None,
False, None,
Line 58: Line 70:
}}
}}


<!--T:15-->
* Functions may return an object that can be used as the base of another drawing function.
* Functions may return an object that can be used as the base of another drawing function.
{{Code|code=
{{Code|code=
Line 64: Line 77:
}}
}}


== Imports ==
== Imports == <!--T:16-->


<!--T:17-->
Python functions are stored in files called modules. Before using any function in that module, the module must be included in the document with the {{incode|import}} instruction.
Python functions are stored in files called modules. Before using any function in that module, the module must be included in the document with the {{incode|import}} instruction.


<!--T:18-->
This creates prefixed functions, that is, {{incode|module.function()}}. This system prevents name clashes with functions that are named the same but that come from different modules.
This creates prefixed functions, that is, {{incode|module.function()}}. This system prevents name clashes with functions that are named the same but that come from different modules.
For example, the two functions {{incode|Arch.makeWindow()}} and {{incode|myModule.makeWindow()}} may coexist without problem.
For example, the two functions {{incode|Arch.makeWindow()}} and {{incode|myModule.makeWindow()}} may coexist without problem.


<!--T:19-->
Full examples should include the necessary imports and the prefixed functions.
Full examples should include the necessary imports and the prefixed functions.


<!--T:20-->
{{Code|code=
{{Code|code=
import FreeCAD, Draft
import FreeCAD, Draft


<!--T:21-->
p1 = FreeCAD.Vector(0, 0, 0)
p1 = FreeCAD.Vector(0, 0, 0)
p2 = FreeCAD.Vector(1, 1, 0)
p2 = FreeCAD.Vector(1, 1, 0)
Line 82: Line 100:
}}
}}


<!--T:22-->
{{Code|code=
{{Code|code=
import FreeCAD, Draft, Arch
import FreeCAD, Draft, Arch


<!--T:23-->
p1 = FreeCAD.Vector(0, 0, 0)
p1 = FreeCAD.Vector(0, 0, 0)
p2 = FreeCAD.Vector(1, 0, 0)
p2 = FreeCAD.Vector(1, 0, 0)
Line 91: Line 111:
pointslist = [p1, p2, p3, p4]
pointslist = [p1, p2, p3, p4]


<!--T:24-->
Wire = Draft.makeWire(pointslist, closed=True, face=True)
Wire = Draft.makeWire(pointslist, closed=True, face=True)
Structure = Arch.makeStructure(Wire, name="Big pillar")
Structure = Arch.makeStructure(Wire, name="Big pillar")

Revision as of 14:33, 7 January 2019

(November 2018) FreeCAD was originally designed to work with Python 2. Many features work with Python 3, but some do not. Making FreeCAD fully support Python 3 is a work in process.

Description

Python is a general purpose, high level programming language that is very commonly used in large applications to automate some tasks by creating scripts or macros.

In FreeCAD, Python code can be used to create various elements programmatically, without needing to click on the graphical user interface. Additionally, many tools and workbenches of FreeCAD are programmed in Python.

See Introduction to Python to learn about the Python programming language, and then Python scripting tutorial and FreeCAD Scripting Basics to start scripting in FreeCAD.

When writing Python code, it's advisable to follow PEP8: Style Guide for Python Code.

Conventions

In this documentation, some conventions for Python examples should be followed.

This is a typical function signature

Wire = makeWire(pointslist, closed=False, placement=None, face=None, support=None)
  • Arguments with key-value pairs are optional, with the default value indicated in the signature. This means that the following calls are equivalent:
Wire = makeWire(pointslist, False, None, None, None)
Wire = makeWire(pointslist, False, None, None)
Wire = makeWire(pointslist, False, None)
Wire = makeWire(pointslist, False)
Wire = makeWire(pointslist)
In this example the first argument doesn't have a default value so it should always be included.
  • When the arguments are given with the explicit key, the optional arguments can be given in any order. This means that the following calls are equivalent:
Wire = makeWire(pointslist, closed=False, placement=None, face=None)
Wire = makeWire(pointslist, closed=False, face=None, placement=None)
Wire = makeWire(pointslist, placement=None, closed=False, face=None)
Wire = makeWire(pointslist, support=None, closed=False, placement=None, face=None)
  • Python's guidelines stress readability of code; in particular, parentheses should immediately follow the function name, and a space should follow a comma.
p1 = Vector(0, 0, 0)
p2 = Vector(1, 1, 0)
p3 = Vector(2, 0, 0)
Wire = makeWire([p1, p2, p3], closed=True)
  • If code needs to be broken over several lines, this should be done at a comma inside brackets or parentheses; the second line should be aligned with the previous one.
a_list = [1, 2, 3,
          2, 4, 5]

Wire = makeWire(pointslist,
                False, None,
                None, None)
  • Functions may return an object that can be used as the base of another drawing function.
Wire = makeWire(pointslist, closed=True, face=True)
Window = makeWindow(Wire, name="Big window")

Imports

Python functions are stored in files called modules. Before using any function in that module, the module must be included in the document with the import instruction.

This creates prefixed functions, that is, module.function(). This system prevents name clashes with functions that are named the same but that come from different modules. For example, the two functions Arch.makeWindow() and myModule.makeWindow() may coexist without problem.

Full examples should include the necessary imports and the prefixed functions.

import FreeCAD, Draft

p1 = FreeCAD.Vector(0, 0, 0)
p2 = FreeCAD.Vector(1, 1, 0)
p3 = FreeCAD.Vector(2, 0, 0)
Wire = Draft.makeWire([p1, p2, p3], closed=True)
import FreeCAD, Draft, Arch

p1 = FreeCAD.Vector(0, 0, 0)
p2 = FreeCAD.Vector(1, 0, 0)
p3 = FreeCAD.Vector(1, 1, 0)
p4 = FreeCAD.Vector(0, 2, 0)
pointslist = [p1, p2, p3, p4]

Wire = Draft.makeWire(pointslist, closed=True, face=True)
Structure = Arch.makeStructure(Wire, name="Big pillar")